package org.openntf.wf.xsp.beans;

import java.io.Serializable;

/**
 * @author Christian Guedemann
 *
 */
public class WFProceedExecutor {

	private final String workflowId;
	private final String boId;
	private final Serializable businessObject;
	private final WorkflowBean bean;
	private String notResponsibleMessage = "Your are not allowed to complete this Workflow-Step!";
	private String targetComponent = null;

	public WFProceedExecutor(WorkflowBean bean, String workFlowId, String boId, Serializable businessObject) {
		this.workflowId = workFlowId;
		this.boId = boId;
		this.bean = bean;
		this.businessObject = businessObject;
	}

	public String getWorkflowId() {
		return workflowId;
	}

	public String getBoId() {
		return boId;
	}

	public Serializable getBusinessObject() {
		return businessObject;
	}

	public WorkflowBean getBean() {
		return bean;
	}

	public String getNotResponsibleMessage() {
		return notResponsibleMessage;
	}

	public String getTargetComponent() {
		return targetComponent;
	}

	public WFProceedExecutor changeNotResponsibleMessage(String message) {
		this.notResponsibleMessage = message;
		return this;
	}

	public WFProceedExecutor changeTargetComponent(String targetId) {
		this.targetComponent = targetId;
		return this;
	}
	
	public boolean execute() {
		return bean.executeProceed(this);
	}

}
